<?php
/*
Plugin Name: Picasaedissimo
Plugin URI: http://www.gofloripa.net/picasedissimo/
Description: Displays pictures from a Picasa RSS feed.
Author: Christian Wolf
Version: 1.1
Author URI: http://www.gofloripa.net/
Remarks: Based heavily on Jon Links Picasaed found on http://taisteal.atomiclemur.com/picasaed/ 
*/

function widget_picasaedissimo($args){
	extract($args);
	$options 	= get_option('widget_picasaedissimo');
	$title 		= $options['title'];
	$feed 		= $options['feed'];
	$number 	= $options['number'];
	$randomize 	= $options['randomize'];
	$open_link	= null;
	$close_link	= null;

	$feed_content	= file_get_contents($feed);

	$close_link	= '</a>';

	// get items
	preg_match_all("/<item.+?<\/item>/si",$feed_content,$items,PREG_SET_ORDER);
	
	if($randomize) {
		shuffle($items);
	}

	//cut down to last n items
	$items = array_reverse(array_slice($items, -$number, $number));


	$i = 0;
	foreach ($items as $item) {
		// parse data from each item
		preg_match("/<title>(.*)<\/title>/si",$item[0],$fotoTitle);
		preg_match("/media:thumbnail url=[\"']([^\"']+)[ a-z='0-9]*216'/si",$item[0],$fotoUrl);
		preg_match("/<link>(.*)<\/link>/si",$item[0],$fotoLink);

		// and store it
		$fotos[$i]['title'] = $fotoTitle[1];
		$fotos[$i]['url'] = $fotoUrl[1];
		$fotos[$i]['link'] = $fotoLink[1];
		$i++;
	}

	// mount html
	$picasa_then = '<ul>'."\n\r";

	foreach($fotos as $foto) {
		$the_title = ($foto['title'])? $foto['title'] : 'Picasa Foto';
		$picasa_then .= "\t".'<li><a href="'.$foto['link'].'" title="'.$foto['title'].'"><img class="picasaedissimo_image" src="'.$foto['url'].'" alt="'.$the_title.'" /></a></li>'."\n\r";
	}
	$picasa_then	.= '</ul>'."\n\r";

	// output html
	echo $before_widget . $before_title . $title . $after_title . $picasa_then . $after_widget;

}

//----control panel
function widget_picasaedissimo_control(){
	$options = $newoptions = get_option('widget_picasaedissimo');
	if($_POST['picasaedissimo_submit']){
		$newoptions['title']	= strip_tags(stripslashes($_POST['picasaedissimo_title']));
		$newoptions['feed']		= strip_tags(stripslashes($_POST['picasaedissimo_feed']));
		$newoptions['randomize'] 	= isset($_POST['picasaedissimo_randomize']);
		$newoptions['number'] 	= strip_tags(stripslashes($_POST['picasaedissimo_number']));
	}
	if($options != $newoptions){
		$options = $newoptions;
		update_option('widget_picasaedissimo', $options);
	}
	$title 		= wp_specialchars($options['title']);
	$feed 		= wp_specialchars($options['feed']);
	$number		= wp_specialchars($options['number']);
	$randomize	= $options['randomize'] ? 'checked="checked"' : '';
?>
<p>
	<label for="picasaedissimo_feed"><?php _e('Picasa RSS feed:'); ?></label>
	<input style="width: 100%;" id="picasaedissimo_feed" name="picasaedissimo_feed" type="text" value="<?php echo $feed; ?>" />
</p>
<p>
	<label for="picasaedissimo_title"><?php _e('Widget Title (optional):'); ?></label>
	<input style="width: 100%;" id="picasaedissimo_title" name="picasaedissimo_title" type="text" value="<?php echo $title; ?>" />
</p>
<p>
	<label for="picasaedissimo_number"><?php _e('Number of images to display:'); ?></label>
	<input style="width: 30%;" id="picasaedissimo_number" name="picasaedissimo_number" type="text" value="<?php echo $number; ?>" />
</p>	
<p>
	<label for="picasaedissimo_link"><?php _e('Randomize Images:'); ?></label>
	<input class="checkbox" type="checkbox" <?php echo $randomize; ?> id="picasaedissimo_link" name="picasaedissimo_randomize" />

</p>
<input type="hidden" id="picasaedissimo_submit" name="picasaedissimo_submit" value="1" />
<?php
}

function picasaedissimo_widget_init(){
	register_widget_control('Picasaedissimo', 'widget_picasaedissimo_control', 485, 230);
	register_sidebar_widget('Picasaedissimo', 'widget_picasaedissimo');
}
add_action('init', 'picasaedissimo_widget_init');
?>